//---------------------------------------------------------------------------


/* Copyright (c) by DATATEC Computer u. Elektronik GmbH

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

******************************************************************
**
** Author Ch. Friedrich 23.5.2001
**
** Dependencies: libmysql.dll
**               MyBackUp.dll
**
*******************************************************************/

/*
  Forgive please, English is not my home-language.

  Note:
  If you operate only with the CBuilder,
  does not need you the component.
  You can use directly the objects from
  the 'MyBackUp.dll'.

  The same program gives it for Delphi 5.
  It is somewhat larger and better. See there.
*/

#include <vcl.h>
#pragma hdrstop
#include "MainUnit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MySQLBackUp"
#pragma link "CSPIN"
#pragma link "MySQLBackUp"
#pragma link "MySQLBackUp"
#pragma resource "*.dfm"
TForm1 *Form1;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

void __fastcall TForm1::FormShow(TObject *Sender)
{
  PagCon->ActivePageIndex=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
 if (MySQLBackUp1->Connected) MySQLBackUp1->DoClose();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtDisconClick(TObject *Sender)
{
  if (MySQLBackUp1->Connected) MySQLBackUp1->DoClose();
}
//---------------------------------------------------------------------------




void __fastcall TForm1::btnConnectClick(TObject *Sender)
{
 MySQLBackUp1->Host=edHost->Text;
 MySQLBackUp1->User=edLogin->Text;
 MySQLBackUp1->Database=edDb->Text;
 MySQLBackUp1->Password=edPswd->Text;
 MySQLBackUp1->Connect();
 if (MySQLBackUp1->GetDatabases())
 {
   LBDatabase->Items->Assign(MySQLBackUp1->Databases);
   LBDatabase->ItemIndex=0;
   LBDatabaseDblClick(this);
 }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::MySQLBackUp1ServerConnect(TObject *Sender,
      TServerInfo &data)
{
  LbConnect->Color=0x0080FF80;
  LbConnect->Caption="Connected";
  BtBackup->Enabled=true;
  BtRestore->Enabled=true;
  BtTableStruct->Enabled=true;
  BtConnect->Enabled=false;
  BtDiscon->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MySQLBackUp1Disconnect(TObject *Sender)
{
   CBTables->Clear();
   LBDatabase->Clear();
   BtBackup->Enabled=false;
   BtRestore->Enabled=false;
   BtTableStruct->Enabled=false;
   BtConnect->Enabled=true;
   BtDiscon->Enabled=false;
   LbConnect->Caption = "DisConnected";
   LbConnect->Color=0x008080FF;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::LBDatabaseDblClick(TObject *Sender)
{
  MySQLBackUp1->WriteLogHeading=true;
  if (LBDatabase->Items->Count < 1) return;
  CBTables->Clear();
  if (MySQLBackUp1->GetTables(LBDatabase->Items->Strings[LBDatabase->ItemIndex]))
     CBTables->Items->Assign(MySQLBackUp1->Tables);
  StBar->SimpleText="Active Database: -> "+LBDatabase->Items->Strings[LBDatabase->ItemIndex];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtSelAllClick(TObject *Sender)
{
  int TC = CBTables->Items->Count;
  for (int i = 0; i < TC; i++)
   if (! CBTables->Checked[i]) CBTables->Checked[i]=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtDeSelAllClick(TObject *Sender)
{
  int TC = CBTables->Items->Count;
  for (int i = 0; i < TC; i++)
   if (CBTables->Checked[i]) CBTables->Checked[i]=false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetOptions(TObject *Sender)
{
    MySQLBackUp1->LockOpt= CBLock->Checked;
    MySQLBackUp1->DropOpt= CBDrop->Checked;
    MySQLBackUp1->tOption= CBtOpt->Checked;
    MySQLBackUp1->cOption= CBcOpt->Checked;
    MySQLBackUp1->MultiTbOpt=CBMulti->Checked;
    MySQLBackUp1->ExtInsOpt =CBExtIns->Checked;
    if (CBwhere->Checked)
    {
      MySQLBackUp1->SqlWhere=EdWhere->Text;
      MySQLBackUp1->WhereOpt=true;
    } else  MySQLBackUp1->WhereOpt=false;
    MySQLBackUp1->ProgressStep=EdInterv->Value;
}


void __fastcall TForm1::BtBackupClick(TObject *Sender)
{
  int TbCount,i;
  AnsiString s;
  Screen->Cursor=crHourGlass;
  SetOptions(this);
  TbCount=0;
  for (i=0;i<CBTables->Items->Count;i++)
  {
      if (CBTables->Checked[i])
      {
          if (CBMulti->Checked) s=EdBackFile->Text;
          else s=CBTables->Items->Strings[i];
          MySQLBackUp1->BackFileName=s+".sql";
          MySQLBackUp1->LogFileName=s+".log";
          MySQLBackUp1->Database=LBDatabase->Items->Strings[LBDatabase->ItemIndex];
          if (MySQLBackUp1->MakeBackUp(CBTables->Items->Strings[i]))
          {
            CBTables->Checked[i]=false;
            TbCount++;
          }
      }
  }
  Screen->Cursor=crDefault;
  MessageDlg(IntToStr(TbCount)+" Tables saved.", mtInformation,TMsgDlgButtons() << mbOK, 0);
  StBar->SimpleText="Active Database: -> "+LBDatabase->Items->Strings[LBDatabase->ItemIndex];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtRestoreClick(TObject *Sender)
{
  int Recs=0;
  if ( Application->MessageBox("May you really execute the Restore-function?", NULL, MB_OKCANCEL) == IDOK)
  {
    Screen->Cursor=crHourGlass;
    OpenDialog1->InitialDir=GetCurrentDir();
    if (OpenDialog1->Execute())
    {
      MySQLBackUp1->RestoreFileName=OpenDialog1->FileName;
      MySQLBackUp1->Database=LBDatabase->Items->Strings[LBDatabase->ItemIndex];
      Recs=MySQLBackUp1->RestoreSQLFile();
      if (Recs)
        MessageDlg(IntToStr(Recs)+" records back-secured.", mtInformation,TMsgDlgButtons() << mbOK, 0);
    }
  }
  Screen->Cursor=crDefault;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PagConChange(TObject *Sender)
{
    if ((PagCon->ActivePage == TSLogFile) &&
          FileExists(MySQLBackUp1->LogFileName))
             Memo1->Lines->LoadFromFile(MySQLBackUp1->LogFileName);
    else if (PagCon->ActivePage == TSStruct)
        LBStrTabs->Items->Assign(CBTables->Items);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::LBStrTabsDblClick(TObject *Sender)
{
  AnsiString s;
  if (!LBStrTabs->Items->Count) return;

  MySQLBackUp1->MultiTbOpt=false;
  s=LBStrTabs->Items->Strings[LBStrTabs->ItemIndex];
  MySQLBackUp1->BackFileName="Stru_"+s+".sql";
  MySQLBackUp1->Database=LBDatabase->Items->Strings[LBDatabase->ItemIndex];
  MySQLBackUp1->GetTableStructure(s);
  if (FileExists(MySQLBackUp1->BackFileName))
  {
     StructMemo->Lines->LoadFromFile(MySQLBackUp1->BackFileName);
     DeleteFile(MySQLBackUp1->BackFileName);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CBwhereClick(TObject *Sender)
{
 EdWhere->Visible= CBwhere->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtCloseClick(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MySQLBackUp1MyDataError(TObject *Sender,
      TMyErrRec &ErrInfo)
{
   MessageDlg(ErrInfo.MyErrStr, mtError,TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MySQLBackUp1AfterDump(TObject *Sender,
      TMyDumpRec &DumpInfo)
{
  StBar->SimpleText="Table: -> "+DumpInfo.Table+
  " records: "+IntToStr(DumpInfo.Records)+" successfully";
}
//---------------------------------------------------------------------------

